using System;

namespace MyTM
{
	/// <summary>
	/*  Transaction Manager */
	/// </summary>
	public class MyTM: System.MarshalByRefObject, TP.TM
	{
		public MyTM()
		{
			System.Console.WriteLine("Transaction Manager instantiated");
		}

		[System.Serializable()]
		class Transaction : TP.Transaction
		{
		}

		public TP.Transaction Start()
		{
			Transaction context = new Transaction();
			System.Console.WriteLine( string.Format("TM: Transaction {0} started", context.Id));
			return context;
		}

	/// <summary>
	//	 Call from WC in response to a client's commit
	/// </summary>
	/// <param name="context"></param>
	public void Commit(TP.Transaction context)
	{
		System.Console.WriteLine(string.Format("Transaction {0} commited", context.Id));
	}

	/// <summary>
	// Call from WC in response to a client's abort
	/// </summary>
	/// <param name="context"></param>
	public void Abort(TP.Transaction context)
	{
		System.Console.WriteLine(string.Format("Transaction {0} aborted", context.Id));
	}

	/// <summary>
	/*  Called by RM.
		This method notifies TM that it is involved in a given transaction
		TM keeps track of which RM is enlisted with which transaction to do distributed transactions */
	/// </summary>
	/// <param name="context"></param>
	public void Enlist(TP.Transaction context, TP.RM enlistingRM)
	{
		System.Console.WriteLine(string.Format( "Transaction {0} enlisted", context.Id ));
	}

	static void Main(string [] args)
	{
		System.Runtime.Remoting.Channels.Http.HttpChannel channel = new System.Runtime.Remoting.Channels.Http.HttpChannel(8081);
		
		System.Runtime.Remoting.Channels.ChannelServices.RegisterChannel(channel);

        System.Runtime.Remoting.RemotingConfiguration.RegisterWellKnownServiceType
		(	       	Type.GetType("MyTM.MyTM")								// full type name
			    ,	"TM.soap"												// URI
				,	System.Runtime.Remoting.WellKnownObjectMode.Singleton	// instancing mode
		);

		while(true)
		{
			System.Threading.Thread.Sleep(100000);
		}
	}
}
}
